#include <bits/stdc++.h>
using namespace std;

#define len(x) (int((x).size()))
typedef pair<int, int> pii;

template<typename T>
ostream& operator<<(ostream &out, vector<T> cont) {
    for(auto it=cont.begin(); it != cont.end(); ++it)
        out << (it==cont.begin()?"":" ") << *it;
    return out;
}

int bfs(vector<int> &start, vector<bool> &ok, vector<vector<int>> &E) {
    int res=0;
    for(int st: start) {
        //cerr << "bfs st:" << st << endl;
        if(!ok[st])
            continue;
        //cerr << "bfs st ok" << st << endl;
        res++;
        
        stack<int> stak;
        stak.push(st);
        while(!stak.empty()) {
            int curr = stak.top();
            stak.pop();
            ok[curr] = false;
            
            for(int nex: E[curr]) {
                if(!ok[nex])
                    continue;
                ok[nex] = false;
                stak.push(nex);
            }
        }
    }
    
    return res;
}

int main() {
    int N, M, Qn;
    scanf("%d%d%d", &N, &M, &Qn);
    int sq=int(sqrt(N/(4*log2(N+1))));
    
    vector<vector<int>> E(N);
    vector<set<int>> Eset(N);
    for(int i=0; i<M; ++i) {
        int a, b;
        scanf("%d%d", &a, &b);
        --a, --b;
        E[a].push_back(b);
        E[b].push_back(a);
        if(a > b)
            swap(a, b);
        Eset[a].insert(b);
    }
    
    for(int i=0; i<N; ++i)
        sort(E[i].begin(), E[i].end());
    
    vector<vector<int>> Q(Qn);
    for(int qi=0; qi<Qn; ++qi) {
        int qn;
        scanf("%d", &qn);
        Q[qi].resize(qn);
        for(int i=0; i<qn; ++i) {
            scanf("%d", &Q[qi][i]);
            Q[qi][i]--;
        }
        sort(Q[qi].begin(), Q[qi].end());
    }
        
    vector<bool> ok(N, false);
    
    vector<int> res(Qn);
    for(int qi=0; qi<Qn; ++qi) {
        //cerr << qi << endl;

        
        int qn=len(Q[qi]);
        if(qn < sq) {
            vector<vector<int>> Es(qn);
            for(int i=0; i<qn; ++i) {
                for(int j=i+1; j<qn; ++j) {
                    if(Eset[Q[qi][i]].count(Q[qi][j]) == 0)
                        continue;
                    Es[i].push_back(j);
                    Es[j].push_back(i);
                }
            }
            vector<int> starty(qn);
            vector<bool> oki(qn, true);
            for (int i = 0; i < qn; i++) starty[i] = i;
            res[qi] = bfs(starty, oki, Es);
        } else {
            for(int i=0; i<len(Q[qi]); ++i) {
                ok[Q[qi][i]] = true;
            }
            res[qi] = bfs(Q[qi], ok, E);
        }
        //cerr << "res:" << res[qi] << endl;
    }
    
    for(int qi=0; qi<len(res); ++qi)
        cout << res[qi] << "\n";
    
    return 0;
}