#include <bits/stdc++.h>
using namespace std;

#define len(x) (int((x).size()))
typedef pair<int, int> pii;

template<typename T>
ostream& operator<<(ostream &out, vector<T> cont) {
    for(auto it=cont.begin(); it != cont.end(); ++it)
        out << (it==cont.begin()?"":" ") << *it;
    return out;
}

int bfs(vector<int> &start, vector<bool> &ok, vector<vector<int>> &E) {
    int res=0;
    for(int st: start) {
        //cerr << "bfs st:" << st << endl;
        if(!ok[st])
            continue;
        //cerr << "bfs st ok" << st << endl;
        res++;
        
        stack<int> stak;
        stak.push(st);
        while(!stak.empty()) {
            int curr = stak.top();
            stak.pop();
            ok[curr] = false;
            
            for(int nex: E[curr]) {
                if(!ok[nex])
                    continue;
                ok[nex] = false;
                stak.push(nex);
            }
        }
    }
    
    return res;
}

int main() {
    int N, M, Qn;
    scanf("%d%d%d", &N, &M, &Qn);
    int sq=int(sqrt(N));
    
    vector<vector<int>> E(N);
    for(int i=0; i<M; ++i) {
        int a, b;
        scanf("%d%d", &a, &b);
        --a, --b;
        E[a].push_back(b);
        E[b].push_back(a);
    }
    
    for(int i=0; i<N; ++i)
        sort(E[i].begin(), E[i].end());
    
    vector<vector<int>> small; 
    vector<vector<int>> Q(Qn);
    vector<vector<int>> small_E(N);
    for(int qi=0; qi<Qn; ++qi) {
        int qn;
        scanf("%d", &qn);
        Q[qi].resize(qn);
        for(int i=0; i<qn; ++i) {
            scanf("%d", &Q[qi][i]);
            Q[qi][i]--;
        }
        sort(Q[qi].begin(), Q[qi].end());
        
        if(qn > sq)
            continue;
        for(int i=0; i<qn; ++i)
            for(int j=i+1; j<qn; ++j)
                small.push_back(vector<int>{Q[qi][i], Q[qi][j], qn, i*qn+j});
        small_E[qi].resize(qn*(qn-1)/2, false);
    }
    sort(small.begin(), small.end());
    for(int i=0; i<len(small); ++i)
        cerr << small[i] << endl;
    
    {
        pii pos={-1, -1};
        bool res=0;
        pii prev={-1, -1};
        vector<pii> inform;
        for(int qi=0; qi<len(small); ++qi) {
            pii curr={small[qi][0], small[qi][1]};
            if(prev != curr) {
                for(pii q: inform)
                    small_E[q.first][q.second] = res;
                inform.clear();
                
                if(pos.first != curr.first)
                    pos.second = 0;
                pos.first = curr.first;
                
                for(; pos.second < len(E[pos.first]); pos.second++)
                    if(E[pos.first][pos.second] != curr.second)
                        break;
                if(pos.second < len(E[pos.first]))
                    res = true;
            }
            inform.push_back({small[qi][2], small[qi][3]});
            prev = curr;
        }
    }
    
    vector<bool> ok(N, false);
    vector<vector<int>> Es(N);
    vector<int> res(Qn);
    for(int qi=0; qi<Qn; ++qi) {
        //cerr << qi << endl;
        for(int i=0; i<len(Q[qi]); ++i)
            ok[Q[qi][i]] = true;
        
        int qn=len(Q[qi]);
        if(qn < sq) {
            for(int i=0; i<qn; ++i) {
                for(int j=i+1; j<qn; ++j) {
                    if(!small_E[qi][i*qn+j])
                        continue;
                    Es[i].push_back(j);
                    Es[j].push_back(i);
                }
            }
            res[qi] = bfs(Q[qi], ok, Es);
        } else
            res[qi] = bfs(Q[qi], ok, E);
        //cerr << "res:" << res[qi] << endl;
    }
    
    for(int qi=0; qi<len(res); ++qi)
        cout << res[qi] << "\n";
    
    return 0;
}